#import modules
import tkinter
import visa #Install Pyvisa from ...
import time
import math

def load_form(win):
    #This function adds widgets to the GUI main window
    #Initialize user input dictionary
    UserInputsInit = {}
    
    #Initialize first user input frame and create labels and text entry box
    UserInput1_Frame  = tkinter.Frame(win, width = 75, height = 10)
    UserInput1_Label = tkinter.Label(UserInput1_Frame, text="DUT Supply Voltage:  ", anchor="w")
    UserInput1_EntryBox = tkinter.Entry(UserInput1_Frame, width=5)
    UserInput1_EntryBox.insert(0,'12')
    UserInput1_Units = tkinter.Label(UserInput1_Frame, text=" Volts", anchor="w", width = 20)
    #Now place the first frame and its widgets in the window using pack method
    UserInput1_Frame.pack(side=tkinter.TOP)
    UserInput1_Label.pack(side=tkinter.LEFT, padx=10, pady=6)
    UserInput1_EntryBox.pack(side=tkinter.LEFT)
    UserInput1_Units.pack(side=tkinter.LEFT)
    #Link entry box 1 to our user input dictionary
    UserInputsInit['Vin'] = UserInput1_EntryBox
    
    #Initialize 2nd user input frame and create labels and input text box
    UserInput2_Frame  = tkinter.Frame(win, width = 75)
    UserInput2_Label = tkinter.Label(UserInput2_Frame, text="DUT Supply I Limit: ", anchor="w")
    UserInput2_EntryBox = tkinter.Entry(UserInput2_Frame, width=5)
    UserInput2_EntryBox.insert(0,'3.2')
    UserInput2_Units = tkinter.Label(UserInput2_Frame, text=" Amps", anchor="w", width = 20)
    #Now place the first frame and its widgets in the window using pack method
    UserInput2_Frame.pack(side=tkinter.TOP)
    UserInput2_Label.pack(side=tkinter.LEFT, padx=10, pady=5)
    UserInput2_EntryBox.pack(side=tkinter.LEFT)
    UserInput2_Units.pack(side=tkinter.LEFT)
    #Link entry box 2 to our user input dictionary
    UserInputsInit['VinIlim'] = UserInput2_EntryBox
    
    #Initialize 3rd user input frame and create labels and input text box
    UserInput3_Frame  = tkinter.Frame(win, width = 75)
    UserInput3_Label = tkinter.Label(UserInput3_Frame, text="Load Start Current: ", anchor="w")
    UserInput3_EntryBox = tkinter.Entry(UserInput3_Frame, width=5)
    UserInput3_EntryBox.insert(0,'0')
    UserInput3_Units = tkinter.Label(UserInput3_Frame, text=" Amps", anchor="w", width = 20)
    #Now place the first frame and its widgets in the window using pack method
    UserInput3_Frame.pack(side=tkinter.TOP)
    UserInput3_Label.pack(side=tkinter.LEFT, padx=10, pady=5)
    UserInput3_EntryBox.pack(side=tkinter.LEFT)
    UserInput3_Units.pack(side=tkinter.LEFT)
    #Link entry box 3 to our user input dictionary
    UserInputsInit['StartI'] = UserInput3_EntryBox   

    #Initialize 4th user input frame and create labels and input text box
    UserInput4_Frame  = tkinter.Frame(win, width = 75)
    UserInput4_Label = tkinter.Label(UserInput4_Frame, text="Load Stop Current: ", anchor="w")
    UserInput4_EntryBox = tkinter.Entry(UserInput4_Frame, width=5)
    UserInput4_EntryBox.insert(0,'5')
    UserInput4_Units = tkinter.Label(UserInput4_Frame, text=" Amps", anchor="w", width = 20)
    #Now place the first frame and its widgets in the window using pack method
    UserInput4_Frame.pack(side=tkinter.TOP)
    UserInput4_Label.pack(side=tkinter.LEFT, padx=10, pady=5)
    UserInput4_EntryBox.pack(side=tkinter.LEFT)
    UserInput4_Units.pack(side=tkinter.LEFT)
    #Link entry box 4 to our user input dictionary
    UserInputsInit['StopI'] = UserInput4_EntryBox

    #Initialize 5th user input frame and create labels and input text box
    UserInput5_Frame  = tkinter.Frame(win, width = 75)
    UserInput5_Label = tkinter.Label(UserInput5_Frame, text="Load Current Step: ", anchor="w")
    UserInput5_EntryBox = tkinter.Entry(UserInput5_Frame, width=5)
    UserInput5_EntryBox.insert(0,'1')
    UserInput5_Units = tkinter.Label(UserInput5_Frame, text=" Amps", anchor="w", width = 20)
    #Now place the first frame and its widgets in the window using pack method
    UserInput5_Frame.pack(side=tkinter.TOP)
    UserInput5_Label.pack(side=tkinter.LEFT, padx=10, pady=5)
    UserInput5_EntryBox.pack(side=tkinter.LEFT)
    UserInput5_Units.pack(side=tkinter.LEFT)
    #Link entry box 5 to our user input dictionary
    UserInputsInit['StepI'] = UserInput5_EntryBox
    #Return user inptus list to main program
    
    #Initialize 6th user input frame and create labels and input text box
    UserInput6_Frame  = tkinter.Frame(win, width = 75)
    UserInput6_Label = tkinter.Label(UserInput6_Frame, text="Data File: ", anchor="w")
    UserInput6_EntryBox = tkinter.Entry(UserInput6_Frame, width=25)
    UserInput6_EntryBox.insert(0,'Test1')
    UserInput6_Frame.pack(side=tkinter.TOP)
    UserInput6_Label.pack(side=tkinter.LEFT, padx=10, pady=5)
    UserInput6_EntryBox.pack(side=tkinter.LEFT)
    #Link entry box 6 to our user input dictionary
    UserInputsInit['DataFile'] = UserInput6_EntryBox
    #Return user inptus list to main program
    return UserInputsInit

def InitializeOutput(win):
    #This function adds label widgets for our output data to the GUI main window
    #Create calculation output dictionary
    StepOutput = {}
    
    StepOutput['StepNum'] = tkinter.StringVar(win)
    StepOutput['LoadI'] = tkinter.StringVar(win)
    StepOutput['Vin'] = tkinter.StringVar(win)
    StepOutput['Eff'] = tkinter.StringVar(win)
    
    #Create calc output label widgets
    UserOutput1_Label = tkinter.Label(textvariable=StepOutput['StepNum'], justify = tkinter.LEFT)
    UserOutput2_Label = tkinter.Label(textvariable=StepOutput['LoadI'])
    UserOutput3_Label = tkinter.Label(textvariable=StepOutput['Vin'])
    UserOutput4_Label = tkinter.Label(textvariable=StepOutput['Eff'])
    
    #Initalize calc output widget text
    StepOutput['StepNum'].set("Step: ")
    StepOutput['LoadI'].set("Load Setting = ")
    StepOutput['Vin'].set("Vin at DUT = ")
    StepOutput['Eff'].set("Efficiency = ")
    
    #Place label widgets in the window
    UserOutput1_Label.pack()
    UserOutput2_Label.pack()
    UserOutput3_Label.pack()
    UserOutput4_Label.pack()
    
    return StepOutput

def StartButtonAction(inboxes, outlabels):
    
    ConfigDel = 1 #Configuration delay in seconds
    SetupDel = 0.2 #Setup delay in seconds
    MeasDel = 0.01 #Configure mesure delay in seconds

    rm = visa.ResourceManager()
    SPDadd = 'USB0::0xF4EC::0x1410::SPD1XDAD1R0011::INSTR'
    SDLadd = 'USB0::0xF4EC::0x1620::SDL13FBQ3R0152::INSTR'

    SDMVinadd = 'USB0::0xF4EC::0xEE38::SDM35FAX3R0637::INSTR'
    SDMIinadd = 'USB0::0xF4EC::0xEE38::SDM36FAX1R0084::INSTR'

    SDMVoutadd = 'USB0::0xF4EC::0xEE38::SDM35FAC3R0135::INSTR'
    SDMIoutadd = 'USB0::0xF4EC::0xEE38::SDM36FAX1R0083::INSTR'

    SPD = rm.open_resource(SPDadd)
    SDL = rm.open_resource(SDLadd)

    SDMVin = rm.open_resource(SDMVinadd)
    SDMIin = rm.open_resource(SDMIinadd)

    SDMVout = rm.open_resource(SDMVoutadd)
    SDMIout = rm.open_resource(SDMIoutadd)

    #Collect instrument ID and label
    SPD.write_termination='\n'
    SPD.read_termination='\n'
    SPD.write('*IDN?')
    time.sleep(SetupDel)
    SPDIDN = SPD.read()
    print ("Power Supply: " + str(SPDIDN).rstrip())

    SDL.write('*IDN?')
    time.sleep(SetupDel)
    SDLIDN = SDL.read()
    print ("Load: " + str(SDLIDN).rstrip())
    SDL.write('*RST') #Reset to factory defaults

    SDMVin.write('*IDN?')
    time.sleep(SetupDel)
    SDMVinIDN = SDMVin.read()
    print ("DMM V In: " + str(SDMVinIDN).rstrip())

    SDMIin.write('*IDN?')
    time.sleep(SetupDel)
    SDMIinIDN = SDMIin.read()
    print ("DMM I In: "+ str(SDMIinIDN).rstrip())

    SDMVout.write('*IDN?')
    time.sleep(SetupDel)
    SDMVoutIDN = SDMVout.read()
    print ("DMM V Out: " + str(SDMVoutIDN).rstrip())

    SDMIout.write('*IDN?')
    time.sleep(SetupDel)
    SDMIoutIDN = SDMIout.read()
    print ("DMM I Out: " + str(SDMIoutIDN).rstrip())

    # Initialize load voltage range and current steps
    VLoadRange = 150 #Set load voltage range
    ILoadRange = 5 #set load current range

    # Get GUI inputs
    VSupplyProg = float(inboxes['Vin'].get())
    VSupplySet = VSupplyProg
    ISupplySet = float(inboxes['VinIlim'].get())
    ILoadStart = float(inboxes['StartI'].get())
    ILoadStop = float(inboxes['StopI'].get())
    ILoadIncrement = float(inboxes['StepI'].get())
    Filename = inboxes['DataFile'].get()
    
    # Configure Power Supply
    SPD.write('CH1:VOLT ' + str(VSupplySet))#Send power supply source voltage
    time.sleep(SetupDel)
    SPD.write('CH1:CURR ' + str(ISupplySet)) #Send power supply current limit
    time.sleep(SetupDel)
    
    # Configure Load
    VLoadRange = 150 #Set load voltage range
    if ILoadStop > 5:
        ILoadRange = 30
    else:
        ILoadRange = 5    
    SDL.write(':SOURce:FUNC CURR') #Set load function
    time.sleep(ConfigDel)
    SDL.write(':SOUR:CURR:IRANG ' + str(ILoadRange)) #Set load I Range
    time.sleep(ConfigDel)
    SDL.write(':SOUR:CURR:VRANG ' + str(VLoadRange)) #Set load V Range
    time.sleep(ConfigDel)
    SDL.write(':SOUR:CURR:LEVEL 0') #Set load start current
    time.sleep(ConfigDel)

    #Enable power supply output source, load, and measure
    SPD.write('OUTP CH1,ON') #Enable supply output
    time.sleep(ConfigDel)    
    SDL.write(':INP ON') #Enable load input
    time.sleep(ConfigDel)

    #Format data lists for file save
    ILoadStep = (ILoadStop-ILoadStart)/ILoadIncrement
    if (ILoadStep / math.trunc(ILoadStep)) > 1:
        m = int(ILoadStep) + 3 #Add an extra row as we don't end on an ILoadIcrement interval
        print('Partial last step. Total Steps: ', (m-1))
    else:
        m = int(ILoadStep) + 2 #Number of data rows, load steps to execute/rows in data + header
        print('Total Steps: ', (m-1))
    n = 9 #Number of data columns
    print('Start: ', str(ILoadStart))
    print('Stop: ', str(ILoadStop))
    print('Increment: ', str(ILoadIncrement))
    
    Data_list = [[0 for x in range(n)] for x in range(m)]
    Data_list[0][0] = "ILoad,"
    Data_list[0][1] = "VIn,"
    Data_list[0][2] = "IIn,"
    Data_list[0][3] = "PIn,"
    Data_list[0][4] = "VOut,"
    Data_list[0][5] = "IOut,"
    Data_list[0][6] = "POut,"
    Data_list[0][7] = "Pd,"
    Data_list[0][8] = "Efficiency,"

    i = 1 #Loop iteration counter (rows). 0 is reserved for data header.
  
    #Open file
    f = open(Filename + ".csv", "w")

    while (i < m):
        
        if i == 1:
            print('Start-->:SOURce:CURRent:LEVEL ' + str(ILoadStart))
            SDL.write(':SOURce:CURRent:LEVEL ' + str(ILoadStart)) #Set load current
            f.writelines(Data_list[0][0])
            f.writelines(Data_list[0][1])
            f.writelines(Data_list[0][2])
            f.writelines(Data_list[0][3])
            f.writelines(Data_list[0][4])
            f.writelines(Data_list[0][5])
            f.writelines(Data_list[0][6])
            f.writelines(Data_list[0][7])
            f.writelines(Data_list[0][8])
            f.write("\n")
        else:
            if (ILoadStart + ((i-1) * ILoadIncrement)) > ILoadStop:
                print('End-->:SOURce:CURRent:LEVEL ' + str(ILoadStop))
                SDL.write(':SOURce:CURRent:LEVEL ' + str(ILoadStop))
            else:
                print('Step ', i, '-->:SOURce:CURRent:LEVEL ' + str(ILoadStart + ((i-1) * ILoadIncrement)))
                SDL.write(':SOURce:CURRent:LEVEL ' + str(ILoadStart + ((i-1) * ILoadIncrement))) #Set load start current
        time.sleep(SetupDel)

        SDL.write(':SOURce:CURRent:LEVEL?')
        time.sleep(SetupDel)
        SDLSet = SDL.read()
        print ('Load: ' + str(SDLSet).rstrip())
        Data_list[i][0] = SDLSet.rstrip() #remove whitespace and CR
        f.writelines(str(Data_list[i][0])+",")

        #Adjust source to account for Input I ammeter burden voltage
        #Take one input current reading to set ammeter range
        SDMIout.write('MEAS:CURR:DC?')
        SDMIin.write('MEAS:CURR:DC?')
        time.sleep(SetupDel)
        SDMIoutMeas = SDMIout.read()
        SDMIinMeas = SDMIin.read()
        #Measure intput voltage and adjust power supply so we have VsupplySet at the DUT input
        print('Vin Setting: ' + str(VSupplySet))
        time.sleep(SetupDel)
        SDMVin.write('MEAS:VOLT:DC?')
        SDMVinAdjustMeas = SDMVin.read()
        print('Vin at DUT: ' + str(SDMVinAdjustMeas).rstrip())
        VinError = VSupplyProg - float(SDMVinAdjustMeas)
        print('DUT Vin Error: ' + str(VinError))
        VSupplySet = VSupplySet + VinError
        print('Adjusted Vin: ' + str(VSupplySet))
        SPD.write('CH1:VOLT ' + str(VSupplySet))#Send power supply adjusted source voltage
        time.sleep(SetupDel)
        
        #Send all measure commands
        SDMIout.write('MEAS:CURR:DC?')
        SDMIin.write('MEAS:CURR:DC?')
        SDMVin.write('MEAS:VOLT:DC?')
        SDMVout.write('MEAS:VOLT:DC?')
        time.sleep(MeasDel)
        
        #VIn measure
        #SDMVin.write('MEAS:VOLT:DC?')
        SDMVinMeas = SDMVin.read()
        print ('SDMVIn: ' + str(SDMVinMeas).rstrip())
        Data_list[i][1] = SDMVinMeas.rstrip()#remove whitespace and CR
        f.writelines(str(Data_list[i][1])+",")

        #IIn measure
        #SDMIin.write('MEAS:CURR:DC?')
        SDMIinMeas = SDMIin.read()
        #SDMIinMeas = 1.123 #Placeholder for demo without Qty 4 DMMS
        print ('SDMIIn: ' + str(SDMIinMeas).rstrip())
        Data_list[i][2] = SDMIinMeas.rstrip()#remove whitespace and CR
        f.writelines(str(Data_list[i][2])+",")
        
        #Pin calculation
        Pin = (float(SDMVinMeas) * float(SDMIinMeas))
        print ('Pin: ' + str(Pin))
        Data_list[i][3] = Pin#.rstrip()#remove whitespace and CR
        f.writelines(str(Data_list[i][3])+",")

        #VOut measure
        #SDMVout.write('MEAS:VOLT:DC?')
        SDMVoutMeas = SDMVout.read()
        #SDMVoutMeas = 3.234 #Placeholder for demo without Qty 4 DMMS
        print ('SDMVoutMeas: ' + str(SDMVoutMeas).rstrip())
        Data_list[i][4] = SDMVoutMeas.rstrip()#remove whitespace and CR
        f.writelines(str(Data_list[i][4])+",")

        #Iout measure
        SDMIoutMeas = SDMIout.read()
        print ('SDMIoutMeas: ' + str(SDMIoutMeas).rstrip())
        Data_list[i][5] = SDMIoutMeas.rstrip()#remove whitespace and CR
        f.writelines(str(Data_list[i][5])+",")
        
        #Pout calculation
        Pout = (float(SDMVoutMeas) * float(SDMIoutMeas))
        print ('Pout: ' + str(Pout))
        Data_list[i][6] = str(Pout)#.rstrip()#remove whitespace and CR
        f.writelines(str(Data_list[i][6])+",")

        #Pd calculation
        Pd = (Pin - Pout)
        print ('Pd: ' + str(Pd))
        Data_list[i][7] = str(Pd)#.rstrip()#remove whitespace and CR
        f.writelines(str(Data_list[i][7])+",")
        
        #Efficiency calculation
        Eff = Pout/(Pout + Pd)
        Eff_str = '{:2.2%}'.format(Eff)
        print ('Eff: ' + Eff_str)
        print ()
        Data_list[i][8] = Eff_str
        f.writelines(str(Data_list[i][8])+",")

        #Update GUI Window
        outlabels['StepNum'].set('Step number: ' + str(i) + ' of ' + str(m-1))
        outlabels['LoadI'].set('Load Setting = {:2.5}'.format(SDLSet))
        outlabels['Vin'].set('Vin at DUT = {:2.5}'.format(float(SDMVinMeas)))
        outlabels['Eff'].set('Efficiency = ' + Eff_str)
        main_window.update()

        #print(i,j)
        i += 1
        f.write("\n")
    f.close()   

    #Disable supply output source
    SPD.write('OUTP CH1,OFF') #Turn off power supply
    SDL.write(':INPut OFF') #Turn off load
    print('Sweep Complete. Data saved in ' + Filename+ '.csv')

    #Close communications sessions
    SPD.close()
    SDL.close()
    SDMVin.close()
    SDMIin.close()
    SDMVout.close()
    SDMIout.close()

    #Get the user inputs and run your calulation functions here....
    #outlabels['RoomVolume'].set("Room Volume in cubic feet = " + str(RoomV))
    #outlabels['CFM'].set("CFM = " + str(CFM))
    #outlabels['AirTurns'].set("Air Turnover Time in minutes = " + str(AirT))     


#Run main program
#Create the GUI window
main_window = tkinter.Tk()
main_window.title("PS Efficiency Test")

#Intialize the GUI widgets to define user inputs
UserInputs = load_form(main_window)
#Intialize the GUI widgets to define calculated outputs
CalculatedOuputs = InitializeOutput(main_window)

#Create buttons Calculate button
StartButton = tkinter.Button(text="Start",
    command=(lambda uis=UserInputs, cos=CalculatedOuputs: StartButtonAction(uis, cos)),
    )
#Place Calculate button in window
StartButton.pack(side=tkinter.LEFT, padx=10, pady=6)

#Loop and wait for user intput
main_window.mainloop()

